Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 57128)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 57129)
@@ -444,5 +444,5 @@
 void UIMachineWindow::prepareSessionConnections()
 {
-    /* Machine state-change updater: */
+    /* We should watch for console events: */
     connect(uisession(), SIGNAL(sigMachineStateChange()), this, SLOT(sltMachineStateChanged()));
 }
@@ -523,4 +523,10 @@
     UIMachineView::destroy(m_pMachineView);
     m_pMachineView = 0;
+}
+
+void UIMachineWindow::cleanupSessionConnections()
+{
+    /* We should stop watching for console events: */
+    disconnect(uisession(), SIGNAL(sigMachineStateChange()), this, SLOT(sltMachineStateChanged()));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 57128)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.h	(revision 57129)
@@ -148,5 +148,5 @@
     virtual void cleanupMenu() {}
     virtual void cleanupMainLayout() {}
-    virtual void cleanupSessionConnections() {}
+    virtual void cleanupSessionConnections();
 
     /* Update stuff: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 57128)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 57129)
@@ -214,29 +214,17 @@
     UIMachineWindow::prepareSessionConnections();
 
-    /* Medium change updater: */
+    /* We should watch for console events: */
     connect(machineLogic()->uisession(), SIGNAL(sigMediumChange(const CMediumAttachment &)),
             this, SLOT(sltMediumChange(const CMediumAttachment &)));
-
-    /* USB controller change updater: */
     connect(machineLogic()->uisession(), SIGNAL(sigUSBControllerChange()),
             this, SLOT(sltUSBControllerChange()));
-
-    /* USB device state-change updater: */
     connect(machineLogic()->uisession(), SIGNAL(sigUSBDeviceStateChange(const CUSBDevice &, bool, const CVirtualBoxErrorInfo &)),
             this, SLOT(sltUSBDeviceStateChange()));
-
-    /* Network adapter change updater: */
     connect(machineLogic()->uisession(), SIGNAL(sigNetworkAdapterChange(const CNetworkAdapter &)),
             this, SLOT(sltNetworkAdapterChange()));
-
-    /* Shared folder change updater: */
     connect(machineLogic()->uisession(), SIGNAL(sigSharedFolderChange()),
             this, SLOT(sltSharedFolderChange()));
-
-    /* Video capture change updater: */
     connect(machineLogic()->uisession(), SIGNAL(sigVideoCaptureChange()),
             this, SLOT(sltVideoCaptureChange()));
-
-    /* CPU execution cap change updater: */
     connect(machineLogic()->uisession(), SIGNAL(sigCPUExecutionCapChange()),
             this, SLOT(sltCPUExecutionCapChange()));
@@ -402,4 +390,26 @@
     /* Call to base-class: */
     UIMachineWindow::saveSettings();
+}
+
+void UIMachineWindowNormal::cleanupSessionConnections()
+{
+    /* We should stop watching for console events: */
+    disconnect(machineLogic()->uisession(), SIGNAL(sigMediumChange(const CMediumAttachment &)),
+               this, SLOT(sltMediumChange(const CMediumAttachment &)));
+    disconnect(machineLogic()->uisession(), SIGNAL(sigUSBControllerChange()),
+               this, SLOT(sltUSBControllerChange()));
+    disconnect(machineLogic()->uisession(), SIGNAL(sigUSBDeviceStateChange(const CUSBDevice &, bool, const CVirtualBoxErrorInfo &)),
+               this, SLOT(sltUSBDeviceStateChange()));
+    disconnect(machineLogic()->uisession(), SIGNAL(sigNetworkAdapterChange(const CNetworkAdapter &)),
+               this, SLOT(sltNetworkAdapterChange()));
+    disconnect(machineLogic()->uisession(), SIGNAL(sigSharedFolderChange()),
+               this, SLOT(sltSharedFolderChange()));
+    disconnect(machineLogic()->uisession(), SIGNAL(sigVideoCaptureChange()),
+               this, SLOT(sltVideoCaptureChange()));
+    disconnect(machineLogic()->uisession(), SIGNAL(sigCPUExecutionCapChange()),
+               this, SLOT(sltCPUExecutionCapChange()));
+
+    /* Call to base-class: */
+    UIMachineWindow::cleanupSessionConnections();
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.h	(revision 57128)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.h	(revision 57129)
@@ -97,4 +97,6 @@
     /** Save settings routine. */
     void saveSettings();
+    /** Cleanup session connections routine. */
+    void cleanupSessionConnections();
 
     /** Updates visibility according to visual-state. */