Index: trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py	(revision 57119)
+++ trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py	(revision 57289)
@@ -1511,74 +1511,75 @@
             # Check basic operations.
             tdTestSessionEx([ # Initial environment is empty.
-                              tdStepSessionCheckEnv(),
-                              # Check clearing empty env.
-                              tdStepSessionClearEnv(),
-                              tdStepSessionCheckEnv(),
-                              # Check set.
-                              tdStepSessionSetEnv('FOO', 'BAR'),
-                              tdStepSessionCheckEnv(['FOO=BAR',]),
-                              tdStepRequireMinimumApiVer(5.0), # 4.3 can't cope with the remainder.
-                              tdStepSessionClearEnv(),
-                              tdStepSessionCheckEnv(),
-                              # Check unset.
-                              tdStepSessionUnsetEnv('BAR'),
-                              tdStepSessionCheckEnv(['BAR']),
-                              tdStepSessionClearEnv(),
-                              tdStepSessionCheckEnv(),
-                              # Set + unset.
-                              tdStepSessionSetEnv('FOO', 'BAR'),
-                              tdStepSessionCheckEnv(['FOO=BAR',]),
-                              tdStepSessionUnsetEnv('FOO'),
-                              tdStepSessionCheckEnv(['FOO']),
-                              # Bulk environment changes (via attrib) (shall replace existing 'FOO').
-                              tdStepSessionBulkEnv( ['PATH=/bin:/usr/bin', 'TMPDIR=/var/tmp', 'USER=root']),
-                              tdStepSessionCheckEnv(['PATH=/bin:/usr/bin', 'TMPDIR=/var/tmp', 'USER=root']),
-                              ]),
+                tdStepSessionCheckEnv(),
+                # Check clearing empty env.
+                tdStepSessionClearEnv(),
+                tdStepSessionCheckEnv(),
+                # Check set.
+                tdStepSessionSetEnv('FOO', 'BAR'),
+                tdStepSessionCheckEnv(['FOO=BAR',]),
+                tdStepRequireMinimumApiVer(5.0), # 4.3 can't cope with the remainder.
+                tdStepSessionClearEnv(),
+                tdStepSessionCheckEnv(),
+                # Check unset.
+                tdStepSessionUnsetEnv('BAR'),
+                tdStepSessionCheckEnv(['BAR']),
+                tdStepSessionClearEnv(),
+                tdStepSessionCheckEnv(),
+                # Set + unset.
+                tdStepSessionSetEnv('FOO', 'BAR'),
+                tdStepSessionCheckEnv(['FOO=BAR',]),
+                tdStepSessionUnsetEnv('FOO'),
+                tdStepSessionCheckEnv(['FOO']),
+                # Bulk environment changes (via attrib) (shall replace existing 'FOO').
+                tdStepSessionBulkEnv( ['PATH=/bin:/usr/bin', 'TMPDIR=/var/tmp', 'USER=root']),
+                tdStepSessionCheckEnv(['PATH=/bin:/usr/bin', 'TMPDIR=/var/tmp', 'USER=root']),
+                ]),
             tdTestSessionEx([ # Check that setting the same value several times works.
-                              tdStepSessionSetEnv('FOO','BAR'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR',]),
-                              tdStepSessionSetEnv('FOO','BAR2'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR2',]),
-                              tdStepSessionSetEnv('FOO','BAR3'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR3',]),
-                              tdStepRequireMinimumApiVer(5.0), # 4.3 can't cope with the remainder.
-                              # Add a little unsetting to the mix.
-                              tdStepSessionSetEnv('BAR', 'BEAR'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR3', 'BAR=BEAR',]),
-                              tdStepSessionUnsetEnv('FOO'),
-                              tdStepSessionCheckEnv([ 'FOO', 'BAR=BEAR',]),
-                              tdStepSessionSetEnv('FOO','BAR4'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR4', 'BAR=BEAR',]),
-                              # The environment is case sensitive.
-                              tdStepSessionSetEnv('foo','BAR5'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR4', 'BAR=BEAR', 'foo=BAR5']),
-                              tdStepSessionUnsetEnv('foo'),
-                              tdStepSessionCheckEnv([ 'FOO=BAR4', 'BAR=BEAR', 'foo']),
-                              ]),
+                tdStepSessionSetEnv('FOO','BAR'),
+                tdStepSessionCheckEnv([ 'FOO=BAR',]),
+                tdStepSessionSetEnv('FOO','BAR2'),
+                tdStepSessionCheckEnv([ 'FOO=BAR2',]),
+                tdStepSessionSetEnv('FOO','BAR3'),
+                tdStepSessionCheckEnv([ 'FOO=BAR3',]),
+                tdStepRequireMinimumApiVer(5.0), # 4.3 can't cope with the remainder.
+                # Add a little unsetting to the mix.
+                tdStepSessionSetEnv('BAR', 'BEAR'),
+                tdStepSessionCheckEnv([ 'FOO=BAR3', 'BAR=BEAR',]),
+                tdStepSessionUnsetEnv('FOO'),
+                tdStepSessionCheckEnv([ 'FOO', 'BAR=BEAR',]),
+                tdStepSessionSetEnv('FOO','BAR4'),
+                tdStepSessionCheckEnv([ 'FOO=BAR4', 'BAR=BEAR',]),
+                # The environment is case sensitive.
+                tdStepSessionSetEnv('foo','BAR5'),
+                tdStepSessionCheckEnv([ 'FOO=BAR4', 'BAR=BEAR', 'foo=BAR5']),
+                tdStepSessionUnsetEnv('foo'),
+                tdStepSessionCheckEnv([ 'FOO=BAR4', 'BAR=BEAR', 'foo']),
+                ]),
             tdTestSessionEx([ # Bulk settings merges stuff, last entry standing.
-                              tdStepSessionBulkEnv(['FOO=bar', 'foo=bar', 'FOO=doofus', 'TMPDIR=/tmp', 'foo=bar2']),
-                              tdStepSessionCheckEnv(['FOO=doofus', 'TMPDIR=/tmp', 'foo=bar2']),
-                              tdStepRequireMinimumApiVer(5.0), # 4.3 is buggy!
-                              tdStepSessionBulkEnv(['2=1+1', 'FOO=doofus2', ]),
-                              tdStepSessionCheckEnv(['2=1+1', 'FOO=doofus2' ]),
-                              ]),
+                tdStepSessionBulkEnv(['FOO=bar', 'foo=bar', 'FOO=doofus', 'TMPDIR=/tmp', 'foo=bar2']),
+                tdStepSessionCheckEnv(['FOO=doofus', 'TMPDIR=/tmp', 'foo=bar2']),
+                tdStepRequireMinimumApiVer(5.0), # 4.3 is buggy!
+                tdStepSessionBulkEnv(['2=1+1', 'FOO=doofus2', ]),
+                tdStepSessionCheckEnv(['2=1+1', 'FOO=doofus2' ]),
+                ]),
             # Invalid variable names.
-            tdTestSessionEx([ tdStepSessionSetEnv('', 'FOO', vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              tdStepRequireMinimumApiVer(5.0), # 4.3 is too relaxed checking input!
-                              tdStepSessionSetEnv('=', '===', vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              tdStepSessionSetEnv('FOO=', 'BAR', vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              tdStepSessionSetEnv('=FOO', 'BAR', vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              tdStepRequireMinimumApiVer(5.0), # 4.3 is buggy and too relaxed!
-                              tdStepSessionBulkEnv(['', 'foo=bar'], vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              tdStepSessionBulkEnv(['=', 'foo=bar'], vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              tdStepSessionBulkEnv(['=FOO', 'foo=bar'], vbox.ComError.E_INVALIDARG),
-                              tdStepSessionCheckEnv(),
-                              ]),
+            tdTestSessionEx([
+                tdStepSessionSetEnv('', 'FOO', vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                tdStepRequireMinimumApiVer(5.0), # 4.3 is too relaxed checking input!
+                tdStepSessionSetEnv('=', '===', vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                tdStepSessionSetEnv('FOO=', 'BAR', vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                tdStepSessionSetEnv('=FOO', 'BAR', vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                tdStepRequireMinimumApiVer(5.0), # 4.3 is buggy and too relaxed!
+                tdStepSessionBulkEnv(['', 'foo=bar'], vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                tdStepSessionBulkEnv(['=', 'foo=bar'], vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                tdStepSessionBulkEnv(['=FOO', 'foo=bar'], vbox.ComError.E_INVALIDARG),
+                tdStepSessionCheckEnv(),
+                ]),
             # A bit more weird keys/values.
             tdTestSessionEx([ tdStepSessionSetEnv('$$$', ''),
@@ -1586,20 +1587,20 @@
             tdTestSessionEx([ tdStepSessionSetEnv('$$$', '%%%'),
                               tdStepSessionCheckEnv([ '$$$=%%%',]),
-                              ]),
+                            ]),
             tdTestSessionEx([ tdStepRequireMinimumApiVer(5.0), # 4.3 is buggy!
                               tdStepSessionSetEnv(u'ß$%ß&', ''),
                               tdStepSessionCheckEnv([ u'ß$%ß&=',]),
-                              ]),
+                            ]),
             # Misc stuff.
             tdTestSessionEx([ tdStepSessionSetEnv('FOO', ''),
                               tdStepSessionCheckEnv(['FOO=',]),
-                              ]),
+                            ]),
             tdTestSessionEx([ tdStepSessionSetEnv('FOO', 'BAR'),
                               tdStepSessionCheckEnv(['FOO=BAR',])
-                              ],),
+                            ],),
             tdTestSessionEx([ tdStepSessionSetEnv('FOO', 'BAR'),
                               tdStepSessionSetEnv('BAR', 'BAZ'),
                               tdStepSessionCheckEnv([ 'FOO=BAR', 'BAR=BAZ',]),
-                              ]),
+                            ]),
         ];
         return tdTestSessionEx.executeListTestSessions(aoTests, self.oTstDrv, oSession, oTxsSession, oTestVm, 'SessionEnv');
@@ -2522,18 +2523,19 @@
                 [ tdTestDirCreate(sUser = sUser, sPassword = sPassword,
                                   sDirectory = os.path.join(sScratch,
-                                  "".join(random.choice(string.ascii_lowercase) for i in range(32))) ),
+                                                            "".join(random.choice(string.ascii_lowercase) for i in range(32))) ),
                   tdTestResult(fRc = True) ],
                 [ tdTestDirCreate(sUser = sUser, sPassword = sPassword,
                                   sDirectory = os.path.join(sScratch,
-                                  "".join(random.choice(string.ascii_lowercase) for i in range(128))) ),
+                                                            "".join(random.choice(string.ascii_lowercase) for i in range(128))) ),
                   tdTestResult(fRc = True) ],
                 # Following two should fail on Windows (paths too long). Both should timeout.
                 [ tdTestDirCreate(sUser = sUser, sPassword = sPassword,
                                   sDirectory = os.path.join(sScratch,
-                                  "".join(random.choice(string.ascii_lowercase) for i in range(255))) ),
+                                                            "".join(random.choice(string.ascii_lowercase) for i in range(255))) ),
                   tdTestResult(fRc = False) ],
                 [ tdTestDirCreate(sUser = sUser, sPassword = sPassword,
                                   sDirectory = os.path.join(sScratch,
-                                  "".join(random.choice(string.ascii_lowercase) for i in range(1024))) ),
+                                                            "".join(random.choice(string.ascii_lowercase) for i in range(1024)))
+                                 ),
                   tdTestResult(fRc = False) ]
             ]);
@@ -2813,21 +2815,25 @@
             aaTests.extend([
                 # Invalid stuff.
-                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = ''),               tdTestResult(fRc = False) ],
-                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'C:\\Windows'),    tdTestResult(fRc = False) ],
-                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'C:\\Windows'),    tdTestResult(fRc = False) ],
+                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = ''),
+                  tdTestResult(fRc = False) ],
+                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'C:\\Windows'),
+                  tdTestResult(fRc = False) ],
+                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'C:\\Windows'),
+                  tdTestResult(fRc = False) ],
                 # More unusual stuff.
-                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'z:\\'),           tdTestResult(fRc = False) ],
+                [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'z:\\'),
+                  tdTestResult(fRc = False) ],
                 [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = '\\\\uncrulez\\foo'),
-                                                                                                   tdTestResult(fRc = False) ],
+                  tdTestResult(fRc = False) ],
                 # Non-existing stuff.
                 [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Apps\\nonexisting'),
-                                                                                                   tdTestResult(fRc = False) ],
+                  tdTestResult(fRc = False) ],
                 [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Apps\\testFileRemove'),
-                                                                                                   tdTestResult(fRc = False) ],
+                  tdTestResult(fRc = False) ],
                 # Try to delete system files.
                 [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\pagefile.sys'),
-                                                                                                   tdTestResult(fRc = False) ],
+                  tdTestResult(fRc = False) ],
                 [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Windows\\kernel32.sys'),
-                                                                                                   tdTestResult(fRc = False) ]
+                  tdTestResult(fRc = False) ]
             ]);
 
@@ -2836,12 +2842,12 @@
                     # Try delete some unimportant media stuff.
                     [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Windows\\Media\\chimes.wav'),
-                                                                                                   tdTestResult(fRc = True) ],
+                      tdTestResult(fRc = True) ],
                     # Second attempt should fail.
                     [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Windows\\Media\\chimes.wav'),
-                                                                                                   tdTestResult(fRc = False) ],
+                      tdTestResult(fRc = False) ],
                     [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Windows\\Media\\chord.wav'),
-                                                                                                   tdTestResult(fRc = True) ],
+                      tdTestResult(fRc = True) ],
                     [ tdTestFileRemove(sUser = sUser, sPassword = sPassword, sFile = 'c:\\Windows\\Media\\chord.wav'),
-                                                                                                   tdTestResult(fRc = False) ]
+                      tdTestResult(fRc = False) ]
                 ]);
         else:
@@ -2882,5 +2888,5 @@
             tdTestSessionEx([ tdStepStatDir('.'),
                               tdStepStatDir('..'),
-                              ]),
+                            ]),
         ];
         if oTestVm.isWindows():
@@ -2905,5 +2911,5 @@
                                            tdStepStatFile('C:\\Windows\\System32\\kernel32.dll'),
                                            tdStepStatFile('C:/Windows/System32/kernel32.dll')
-                                           ]) ];
+                                         ]) ];
         elif oTestVm.isOS2():
             aoTests += [ tdTestSessionEx([ tdStepStatDir('C:\\OS2'),
@@ -2915,5 +2921,5 @@
                                            tdStepStatFile('C:\\CONFIG.SYS'),
                                            tdStepStatFile('C:\\OS2\\DLL\\DOSCALL1.DLL'),
-                                           ]) ];
+                                         ]) ];
         else: # generic unix.
             aoTests += [ tdTestSessionEx([ tdStepStatDir('/'),
@@ -2926,5 +2932,5 @@
                                            tdStepStatFile('/bin/cp'),
                                            tdStepStatFile('/bin/date'),
-                                           ]) ];
+                                         ]) ];
         # None existing stuff.
         if oTestVm.isWindows() or oTestVm.isOS2():
@@ -2939,5 +2945,5 @@
                                            tdStepStatPathNotFound('N:\\'), # ASSUMES nothing mounted on N:!
                                            tdStepStatPathNotFound('\\\\NoSuchUncServerName\\NoSuchShare'),
-                                           ]) ];
+                                         ]) ];
         else: # generic unix.
             aoTests += [ tdTestSessionEx([ tdStepStatFileNotFound('/NoSuchFileOrDirectory', ),
@@ -2945,5 +2951,5 @@
                                            tdStepStatPathNotFound('/NoSuchDirectory/'),
                                            tdStepStatPathNotFound('/NoSuchDirectory/.'),
-                                           ]) ];
+                                         ]) ];
         # Invalid parameter check.
         aoTests += [ tdTestSessionEx([ tdStepStat('', vbox.ComError.E_INVALIDARG), ]), ];
@@ -3293,31 +3299,44 @@
             aaTests.extend([
                 # Destination missing.
-                [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = ''),                   tdTestResult(fRc = False) ],
+                [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = ''),
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = 'C:\\Windows',
-                               aFlags = [ 1234 ] ),                                                tdTestResult(fRc = False) ],
+                               aFlags = [ 1234 ] ),
+                  tdTestResult(fRc = False) ],
                 # Source missing.
-                [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sDst = ''),                   tdTestResult(fRc = False) ],
+                [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sDst = ''),
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sDst = 'C:\\Windows',
-                               aFlags = [ 1234 ] ),                                                tdTestResult(fRc = False) ],
+                               aFlags = [ 1234 ] ),
+                  tdTestResult(fRc = False) ],
                 # Nothing to copy (source and/or destination is empty).
-                [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = 'z:\\'),               tdTestResult(fRc = False) ],
+                [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = 'z:\\'),
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = '\\\\uncrulez\\foo'),
-                                                                                                   tdTestResult(fRc = False) ],
+
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = 'non-exist',
-                               sDst = os.path.join(sScratch, 'non-exist.dll')),                    tdTestResult(fRc = False) ],
+                               sDst = os.path.join(sScratch, 'non-exist.dll')),
+                  tdTestResult(fRc = False) ],
                 # Copying single files.
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = sVBoxValidationKitISO,
-                               sDst = 'C:\\non-exist\\'),                                          tdTestResult(fRc = False) ],
+                               sDst = 'C:\\non-exist\\'),
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = sVBoxValidationKitISO,
-                               sDst = 'C:\\non\\exist\\'),                                         tdTestResult(fRc = False) ],
+                               sDst = 'C:\\non\\exist\\'),
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = sVBoxValidationKitISO,
-                               sDst = 'C:\\non\\exist\\renamedfile.dll'),                          tdTestResult(fRc = False) ],
+                               sDst = 'C:\\non\\exist\\renamedfile.dll'),
+                  tdTestResult(fRc = False) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = sVBoxValidationKitISO,
-                               sDst = os.path.join(sScratch, 'HostGuestAdditions.iso')),           tdTestResult(fRc = True) ],
+                               sDst = os.path.join(sScratch, 'HostGuestAdditions.iso')),
+                  tdTestResult(fRc = True) ],
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = sVBoxValidationKitISO,
-                               sDst = os.path.join(sScratch, 'HostGuestAdditions.iso')),           tdTestResult(fRc = True) ],
+                               sDst = os.path.join(sScratch, 'HostGuestAdditions.iso')),
+                  tdTestResult(fRc = True) ],
                 # Destination is a directory, should fail.
                 [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = sVBoxValidationKitISO,
-                               sDst = sScratch),                                                   tdTestResult(fRc = False) ]
+                               sDst = sScratch),
+                  tdTestResult(fRc = False) ]
                 ## @todo Add testing the CopyTo flags here!
             ]);
@@ -3328,8 +3347,10 @@
                     # Copying directories with contain files we don't have read access to.
                     [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = 'C:\\Windows\\security',
-                                   sDst = sScratch),                                               tdTestResult(fRc = False) ],
+                                   sDst = sScratch),
+                      tdTestResult(fRc = False) ],
                     # Copying directories with regular files.
                     [ tdTestCopyTo(sUser = sUser, sPassword = sPassword, sSrc = 'C:\\Windows\\Help',
-                                   sDst = sScratch),                                               tdTestResult(fRc = True) ]
+                                   sDst = sScratch),
+                      tdTestResult(fRc = True) ]
                 ]);
         else:
@@ -3392,5 +3413,5 @@
                   tdTestResult(fRc = False) ],
                 [ tdTestCopyFrom(sUser = sUser, sPassword = sPassword, sDst = 'C:\\Windows',
-                               aFlags = [ 1234 ] ),
+                                 aFlags = [ 1234 ] ),
                   tdTestResult(fRc = False) ],
                 # Nothing to copy (sDst is empty / unreachable).
@@ -3401,5 +3422,5 @@
                   tdTestResult(fRc = False) ],
                 [ tdTestCopyFrom(sUser = sUser, sPassword = sPassword, sSrc = 'non-exist',
-                               sDst = os.path.join(sScratch, 'non-exist.dll')),
+                                 sDst = os.path.join(sScratch, 'non-exist.dll')),
                   tdTestResult(fRc = False) ]
                 ## @todo Add testing the CopyFrom aFlags here!
@@ -3422,8 +3443,10 @@
                     # Destination is a directory, should fail.
                     [ tdTestCopyFrom(sUser = sUser, sPassword = sPassword, sSrc = 'C:\\Windows\\system32\\ole32.dll',
-                                   sDst = sScratch),                                                 tdTestResult(fRc = False) ],
+                                     sDst = sScratch),
+                      tdTestResult(fRc = False) ],
                     # Copying directories.
                     [ tdTestCopyFrom(sUser = sUser, sPassword = sPassword, sSrc = 'C:\\Windows\\Web',
-                                   sDst = sScratch),                                                 tdTestResult(fRc = True) ]
+                                     sDst = sScratch),
+                      tdTestResult(fRc = True) ]
                     ## @todo Add testing the CopyFrom aFlags here!
                 ]);
Index: trunk/src/VBox/ValidationKit/tests/network/tdNetBenchmark1.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/network/tdNetBenchmark1.py	(revision 57119)
+++ trunk/src/VBox/ValidationKit/tests/network/tdNetBenchmark1.py	(revision 57289)
@@ -424,7 +424,8 @@
         if fRc and 'tcp-latency' in self.asTests and sAddr is not None:
             for cbPkt in self.acbLatencyPkts:
-                fRc = self.txsRunTest(oTxsSession, '%u bytes' % (cbPkt), self.cSecsRun * 1000 * 4, \
-                    '${CDROM}/${OS/ARCH}/NetPerf${EXESUFF}',
-                        ('NetPerf', '--client', sAddr, '--interval', self.cSecsRun, '--len', cbPkt, '--mode', 'latency'));
+                fRc = self.txsRunTest(oTxsSession, '%u bytes' % (cbPkt), self.cSecsRun * 1000 * 4,
+                                      '${CDROM}/${OS/ARCH}/NetPerf${EXESUFF}',
+                                      ('NetPerf', '--client', sAddr, '--interval', self.cSecsRun, '--len', cbPkt,
+                                       '--mode', 'latency'));
                 if not fRc:
                     break;
@@ -436,7 +437,8 @@
         if fRc and 'tcp-throughput' in self.asTests and sAddr is not None:
             for cbPkt in self.acbThroughputPkts:
-                fRc = self.txsRunTest(oTxsSession, '%u bytes' % (cbPkt), self.cSecsRun * 2 * 1000 * 4, \
-                    '${CDROM}/${OS/ARCH}/NetPerf${EXESUFF}',
-                        ('NetPerf', '--client', sAddr, '--interval', self.cSecsRun, '--len', cbPkt, '--mode', 'throughput'));
+                fRc = self.txsRunTest(oTxsSession, '%u bytes' % (cbPkt), self.cSecsRun * 2 * 1000 * 4,
+                                      '${CDROM}/${OS/ARCH}/NetPerf${EXESUFF}',
+                                      ('NetPerf', '--client', sAddr, '--interval', self.cSecsRun, '--len', cbPkt,
+                                       '--mode', 'throughput'));
                 if not fRc:
                     break;
@@ -587,5 +589,5 @@
             # Start the test servers on it.
             fRc = self.oGuestToGuestTxs.syncExec('${CDROM}/${OS/ARCH}/NetPerf${EXESUFF}',
-                    ('NetPerf', '--server', '--daemonize'), fWithTestPipe=False);
+                                                 ('NetPerf', '--server', '--daemonize'), fWithTestPipe=False);
 
         # Loop thru the test VMs.
Index: trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py	(revision 57119)
+++ trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py	(revision 57289)
@@ -409,13 +409,13 @@
         # Prepare test disk, just create filesystem without partition
         reporter.testStart('mkfs.ext4');
-        fRc = self.txsRunTest(oTxsSession, 'Create FS', 60000, \
-            '/sbin/mkfs.ext4',
-                ('mkfs.ext4', '-F', '/dev/vboxtest'));
+        fRc = self.txsRunTest(oTxsSession, 'Create FS', 60000,
+                              '/sbin/mkfs.ext4',
+                              ('mkfs.ext4', '-F', '/dev/vboxtest'));
         reporter.testDone();
 
         reporter.testStart('mount');
-        fRc = self.txsRunTest(oTxsSession, 'Mount FS', 30000, \
-            '/bin/mount',
-                ('mount', '/dev/vboxtest', '/mnt'));
+        fRc = self.txsRunTest(oTxsSession, 'Mount FS', 30000,
+                              '/bin/mount',
+                              ('mount', '/dev/vboxtest', '/mnt'));
         reporter.testDone();
 
@@ -423,8 +423,9 @@
         if fRc and 'iozone' in self.asTests:
             oStdOut = IozoneStdOutWrapper();
-            fRc = self.txsRunTestRedirectStd(oTxsSession, '2G', 3600000, \
-                '/usr/bin/iozone',
-                    ('iozone', '-r', '64k', '-s', '2g', '-t', '1', '-T', '-I', '-H', '32','-F', '/mnt/iozone'), \
-                (), '', '/dev/null', oStdOut, '/dev/null', '/dev/null');
+            fRc = self.txsRunTestRedirectStd(oTxsSession, '2G', 3600000,
+                                             '/usr/bin/iozone',
+                                             ('iozone', '-r', '64k', '-s', '2g', '-t', '1', '-T', '-I',
+                                              '-H', '32','-F', '/mnt/iozone'),
+                                             (), '', '/dev/null', oStdOut, '/dev/null', '/dev/null');
             if fRc is True:
                 reporter.log("Initial writer: " + str(oStdOut.getInitWriter()));
@@ -447,7 +448,7 @@
             oFioWrapper = FioWrapper('64k', '2g', '32', '/mnt');
             fRc = self.txsUploadString(oSession, oTxsSession, oFioWrapper.getConfig(), '${SCRATCH}/aio-test');
-            fRc = fRc and self.txsRunTestRedirectStd(oTxsSession, '2G', 3600000, \
-                '/usr/bin/fio', ('fio', '${SCRATCH}/aio-test'), \
-                (), '', '/dev/null', oFioWrapper, '/dev/null', '/dev/null');
+            fRc = fRc and self.txsRunTestRedirectStd(oTxsSession, '2G', 3600000,
+                                                     '/usr/bin/fio', ('fio', '${SCRATCH}/aio-test'),
+                                                     (), '', '/dev/null', oFioWrapper, '/dev/null', '/dev/null');
         else:
             reporter.testDone(fSkipped = True);
Index: trunk/src/VBox/ValidationKit/tests/storage/tdStorageStress1.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/storage/tdStorageStress1.py	(revision 57119)
+++ trunk/src/VBox/ValidationKit/tests/storage/tdStorageStress1.py	(revision 57289)
@@ -209,8 +209,8 @@
         # Some stupid trickery to guess the location of the iso. ## fixme - testsuite unzip ++
         sVBoxValidationKit_iso = os.path.abspath(os.path.join(os.path.dirname(__file__),
-                                                 '../../VBoxValidationKitStorIo.iso'));
+                                                              '../../VBoxValidationKitStorIo.iso'));
         if not os.path.isfile(sVBoxValidationKit_iso):
             sVBoxValidationKit_iso = os.path.abspath(os.path.join(os.path.dirname(__file__),
-                                                     '../../VBoxValidationKitStorIo.iso'));
+                                                                  '../../VBoxValidationKitStorIo.iso'));
         if not os.path.isfile(sVBoxValidationKit_iso):
             sVBoxValidationKit_iso = '/mnt/ramdisk/vbox/svn/trunk/validationkit/VBoxValidationKitStorIo.iso';
@@ -314,9 +314,9 @@
         reporter.testStart('xfstests');
         if fRc and 'xfstests' in self.asTests:
-            fRc = self.txsRunTest(oTxsSession, 'xfstests', 3600000, \
-                '/bin/sh',
-                    ('sh', '-c', '(cd /tmp/xfstests && ./check -g auto)'), \
-                    ('TEST_DIR=/mnt/test', 'TEST_DEV=/dev/sdb', 'SCRATCH_MNT=/mnt/scratch', 'SCRATCH_DEV=/dev/sdc', \
-                     'FSTYP=' + sGuestFs));
+            fRc = self.txsRunTest(oTxsSession, 'xfstests', 3600000,
+                                  '/bin/sh',
+                                  ('sh', '-c', '(cd /tmp/xfstests && ./check -g auto)'),
+                                  ('TEST_DIR=/mnt/test', 'TEST_DEV=/dev/sdb', 'SCRATCH_MNT=/mnt/scratch', 'SCRATCH_DEV=/dev/sdc',
+                                   'FSTYP=' + sGuestFs));
             reporter.testDone();
         else:
Index: trunk/src/VBox/ValidationKit/tests/unittests/tdUnitTest1.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/unittests/tdUnitTest1.py	(revision 57119)
+++ trunk/src/VBox/ValidationKit/tests/unittests/tdUnitTest1.py	(revision 57289)
@@ -171,7 +171,7 @@
         'testcase/tstCryptoPkcs7Sign': '',# failed: 29330:error:02001002:lib(2):func(1):reason(2):NA:0:fopen('server.pem': '','r')
         'testcase/tstCompressionBenchmark': '', # failed: error: RTZipBlockCompress failed
-                                        # for 'RTZipBlock/LZJB' (#4): VERR_NOT_SUPPORTED
+                                                # for 'RTZipBlock/LZJB' (#4): VERR_NOT_SUPPORTED
         'testcase/tstLdr-4': '',            # failed: Failed to get bits for '/home/vbox/test/tmp/bin/testcase/tstLdrObjR0.r0'/0,
-                                        # rc=VERR_SYMBOL_VALUE_TOO_BIG. aborting test
+                                            # rc=VERR_SYMBOL_VALUE_TOO_BIG. aborting test
         'tstPDMAsyncCompletionStress': '',  # VERR_INVALID_PARAMETER (cbSize = 0)
         'tstMicro': '',                     # doesn't work on solaris, fix later if we care.
@@ -622,5 +622,5 @@
             except:
                 if sName in [ 'tstAsmStructsRC',    # 32-bit, may fail to start on 64-bit linux. Just ignore.
-                              ]:
+                            ]:
                     reporter.logXcpt();
                     fSkipped = True;